#! /bin/bash

# Expect a pathname as the first argument.

FILE=$1
DIR=`dirname ${FILE}`
BASE=`basename ${FILE}`

# Set up to run as many MPI processes per tasks as number of cores
# per worker provided by WQ_CPT. Method here is relatively insensitive
# to the version of MPI being used.

PROCS=${WQ_CPT}
HOSTNAME=`uname -n`
HOSTLIST=""
for i in `seq 1 ${PROCS}`; do
   HOSTLIST="${HOSTNAME},${HOSTLIST}"
done 
HOSTLIST=${HOSTLIST%,*}

# Here we set the command line to use. It assumes that the executable,
# 'mb', is in the shell's PATH. We also use the numactl command
# provided in the WQ_NUMACTL variable.

CMD="${WQ_NUMACTL}"
CMD="${CMD} mpirun -host ${HOSTLIST} -np ${PROCS} mb"
CMD="${CMD} ${FILE} < /dev/null > ${BASE}.mb.log"

cd $DIR

# Clean out any cruft from possible previous run.

rm -f ${BASE}.[pt] ${BASE}.log ${BASE}.ckp ${BASE}.ckp~ ${BASE}.mcmc

# For testing purposes, use "if false". For production, use "if true"


if false ; then
   eval "${CMD}"
else
   echo "Would have executed the following command:"
   echo "${CMD}"
   T=`expr 2 + $RANDOM % 10`
   echo "Sleeping for $T seconds."
   sleep $T
fi
