proc Debug { msg } {
    tk_messageBox -icon info -type ok -message $msg
}

proc Time2Secs { t } {
    # Convert hh, hh:mm or hh:mm:ss to seconds
    # Throw away any fractions so we can deal with integer arithmetic.
    set v [lindex [split [split $t "."] :] 0]
    Debug $t
    set s 0
    switch [llength $v] {
	1 { set s [expr [lindex $v 0] * 3600]}
	2 { set s [expr [lindex $v 0] * 3600 + [lindex $v 1] * 60] }
	3 { set s [expr [lindex $v 0] * 3600 + [lindex $v 1] * 60 \
		       + [lindex $v 2]]}
	default {  tk_messageBox -icon error -type ok \
		       -message "\"$t\" not a valid time!" }
    }
}

proc Secs2Time { s } {
    # Convert seconds to hh:mm:ss
    # Throw away any fractions so we can deal with integer arithmetic.

    set v [lindex [split $s .] 0]
    set h [expr $v / 3600]
    set v [expr $v % 3600]
    if { $v > 0 } {
	set m [expr $v / 60]
	set s [expr $v % 60]
    } else {
	set m 0
	set s 0
    }
    return [format "%02d:%02d:%02d" $h $m $s]
}

Debug "
32 = [Time2Secs 32]
1:30 = [Time2Secs 1:30]
0:1:45 = [Time2Secs 0:1:45]
0:1:2:3 = [Time2Secs 0:1:2:3]
-1 = [Time2Secs -1]

325 = [Secs2Time 325]
8500 = [Secs2Time 8500]"

