#!/usr/bin/env python
#
# Ingests a WQ verbose (!) log file and histograms the task
# times.

import matplotlib.pyplot as plt
import sys
from math import floor, ceil

if len(sys.argv) != 3:
    print 'Usage: histogram.py logfile bins'
    print '   Must be a verbose logfile.'
    sys.exit(1)

fh = open(sys.argv[1],'rb')
lines = fh.readlines()
fh.close()

if int(sys.argv[2]) > 0:
    usebins = int(sys.argv[2])
    
x = []
xmax = 0.0
xmin = 1.e+37

for line in lines:
    l = line.split(':')
    if (l[0] == 'Worker') and (l[1] == 'Timings'):
        t = float(l[6].strip())
        if t > xmax:
            xmax = t
        if t < xmin:
            xmin = t
        x.append(t)

# the histogram of the data

n, bins, patches = plt.hist(x, bins=usebins)

plt.xlabel('Times')
plt.ylabel('Occurances')
plt.title('Histogram of %d Task Times'%len(x))
plt.axis([floor(xmin)-1, ceil(xmax), 0, max(n)])
plt.grid(True)

plt.show()
